# octavia.controller.worker package

## Subpackages

- octavia.controller.worker.v1 package
  - Subpackages
    - octavia.controller.worker.v1.flows package
      - Submodules
      - octavia.controller.worker.v1.flows.amphora_flows module
      - octavia.controller.worker.v1.flows.health_monitor_flows module
      - octavia.controller.worker.v1.flows.l7policy_flows module
      - octavia.controller.worker.v1.flows.l7rule_flows module
      - octavia.controller.worker.v1.flows.listener_flows module
      - octavia.controller.worker.v1.flows.load_balancer_flows module
      - octavia.controller.worker.v1.flows.member_flows module
      - octavia.controller.worker.v1.flows.pool_flows module
      - Module contents
    - octavia.controller.worker.v1.tasks package
      - Submodules
      - octavia.controller.worker.v1.tasks.amphora_driver_tasks module
      - octavia.controller.worker.v1.tasks.cert_task module
      - octavia.controller.worker.v1.tasks.compute_tasks module
      - octavia.controller.worker.v1.tasks.database_tasks module
      - octavia.controller.worker.v1.tasks.lifecycle_tasks module
      - octavia.controller.worker.v1.tasks.model_tasks module
      - octavia.controller.worker.v1.tasks.network_tasks module
      - octavia.controller.worker.v1.tasks.retry_tasks module
      - Module contents
  - Submodules
  - octavia.controller.worker.v1.controller_worker module
  - Module contents
- octavia.controller.worker.v2 package
  - Subpackages
    - octavia.controller.worker.v2.flows package
      - Submodules
      - octavia.controller.worker.v2.flows.amphora_flows module
      - octavia.controller.worker.v2.flows.flow_utils module
      - octavia.controller.worker.v2.flows.health_monitor_flows module
      - octavia.controller.worker.v2.flows.l7policy_flows module
      - octavia.controller.worker.v2.flows.l7rule_flows module
      - octavia.controller.worker.v2.flows.listener_flows module
      - octavia.controller.worker.v2.flows.load_balancer_flows module
      - octavia.controller.worker.v2.flows.member_flows module
      - octavia.controller.worker.v2.flows.pool_flows module
      - Module contents
    - octavia.controller.worker.v2.tasks package
      - Submodules
      - octavia.controller.worker.v2.tasks.amphora_driver_tasks module
      - octavia.controller.worker.v2.tasks.cert_task module
      - octavia.controller.worker.v2.tasks.compute_tasks module
      - octavia.controller.worker.v2.tasks.database_tasks module
      - octavia.controller.worker.v2.tasks.lifecycle_tasks module
      - octavia.controller.worker.v2.tasks.network_tasks module
      - octavia.controller.worker.v2.tasks.retry_tasks module
      - Module contents
  - Submodules
  - octavia.controller.worker.v2.controller_worker module
  - octavia.controller.worker.v2.taskflow_jobboard_driver module
  - Module contents

## Submodules

## octavia.controller.worker.amphora_rate_limit module

class AmphoraBuildRateLimit

  Bases: `object`

  add_to_build_request_queue(amphora_id, build_priority)
  has_build_slot()
  has_highest_priority(amphora_id)
  remove_all_from_build_req_queue()
  remove_from_build_req_queue(amphora_id)
  update_build_status_and_available_build_slots(amphora_id)
  wait_for_build_slot(amphora_id)

## octavia.controller.worker.task_utils module

Methods common to the controller work tasks.

class TaskUtils(**kwargs)

  Bases: `object`

  Class of helper/utility methods used by tasks.

  get_current_loadbalancer_from_db(loadbalancer_id)

    Gets a Loadbalancer from db.

    Param

      loadbalancer_id: Load balancer ID which to get from db

  mark_amphora_status_error(amphora_id)

    Sets an amphora status to ERROR.

    NOTE: This should only be called from revert methods.

    Parameters

      amphora_id – Amphora ID to set the status to ERROR

  mark_health_mon_prov_status_error(health_mon_id)

    Sets a health monitor provisioning status to ERROR.

    NOTE: This should only be called from revert methods.

    Parameters

      health_mon_id – Health Monitor ID to set prov status to ERROR

  mark_l7policy_prov_status_active(l7policy_id)

    Sets a L7 policy provisioning status to ACTIVE.

    NOTE: This should only be called from revert methods.

    Parameters

      l7policy_id – L7 Policy ID to set provisioning status to ACTIVE

  mark_l7policy_prov_status_error(l7policy_id)

    Sets a L7 policy provisioning status to ERROR.

    NOTE: This should only be called from revert methods.

    Parameters

      l7policy_id – L7 Policy ID to set provisioning status to ERROR

  mark_l7rule_prov_status_error(l7rule_id)

    Sets a L7 rule provisioning status to ERROR.

    NOTE: This should only be called from revert methods.

    Parameters

      l7rule_id – L7 Rule ID to set provisioning status to ERROR

  mark_listener_prov_status_active(listener_id)

    Sets a listener provisioning status to ACTIVE.

    NOTE: This should only be called from revert methods.

    Parameters

      listener_id – Listener ID to set provisioning status to ACTIVE

  mark_listener_prov_status_error(listener_id)

    Sets a listener provisioning status to ERROR.

    NOTE: This should only be called from revert methods.

    Parameters

      listener_id – Listener ID to set provisioning status to ERROR

  mark_loadbalancer_prov_status_active(loadbalancer_id)

    Sets a load balancer provisioning status to ACTIVE.

    NOTE: This should only be called from revert methods.

    Parameters

      loadbalancer_id – Load balancer ID to set provisioning status to ACTIVE

  mark_loadbalancer_prov_status_error(loadbalancer_id)

    Sets a load balancer provisioning status to ERROR.

    NOTE: This should only be called from revert methods.

    Parameters

      loadbalancer_id – Load balancer ID to set provisioning status to ERROR

  mark_member_prov_status_error(member_id)

    Sets a member provisioning status to ERROR.

    NOTE: This should only be called from revert methods.

    Parameters

      member_id – Member ID to set provisioning status to ERROR

  mark_pool_prov_status_active(pool_id)

    Sets a pool provisioning status to ACTIVE.

    NOTE: This should only be called from revert methods.

    Parameters

      pool_id – Pool ID to set provisioning status to ACTIVE

  mark_pool_prov_status_error(pool_id)

    Sets a pool provisioning status to ERROR.

    NOTE: This should only be called from revert methods.

    Parameters

      pool_id – Pool ID to set provisioning status to ERROR

  status_update_retry()
  unmark_amphora_health_busy(amphora_id)

    Unmark the amphora_health record busy for an amphora.

    NOTE: This should only be called from revert methods.

    Parameters

      amphora_id – The amphora id to unmark busy

## Module contents

this page last updated: 2026-03-10 21:33:29

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.

found an error? report a bug